<?php
if(!defined('checkaccess')){die('Direct access not permitted');}
// For SBFspot https://sbfspot.codeplex.com/
// Use $COMOPTION for SBFspot CSV command switches (-ad# -am# -nocsv etc)

// Timeout setup : for SBFspot timeout management by 123Solar
// ( relies on timeout command )
$datareturn = null; 

$timeout_setup = "timeout --kill-after=10s 5s"; // TERM after 5" & KILL after 10"
$cfgdir = dirname($SCRDIR) . '/config';
//echo $cfgdir;

if (!$DEBUG) {
    $CMD_POOLING = $timeout_setup . " /usr/bin/SBFspot -finq -q -123s=DATA -cfg" . $cfgdir . "/SBFspot_${'ADR'.$invt_num}.cfg ${'COMOPTION'.$invt_num}";
} else { // This output is really verbose and does not respect the 123s data frame, hence why you will had no data
    $CMD_POOLING = $timeout_setup . " /usr/bin/SBFspot -finq -d5 -v5 -123s=DATA -cfg" . $cfgdir . "/SBFspot_${'ADR'.$invt_num}.cfg ${'COMOPTION'.$invt_num}"; // Pooling with errors output ?
}

$datareturn = exec($CMD_POOLING);
$array      = preg_split('/[[:space:]]+/', $datareturn);
if (isset($array[24])) { // SBFspot might send trames shorter than 24
    if ($array[24] == '>>>S123:OK') {
        $SDTE = $array[0];
        $G1V  = $array[1]; // GridMs.PhV.phsA
        settype($G1V, 'float');
        $G1A = $array[2]; // GridMs.A.phsA
        settype($G1A, 'float');
        $G1P = $array[3]; // GridMs.W.phsA
        settype($G1P, 'float');
        $G2V = $array[4]; // GridMs.PhV.phsB
        settype($G2V, 'float');
        $G2A = $array[5]; // GridMs.A.phsB
        settype($G2A, 'float');
        $G2P = $array[6]; // GridMs.W.phsB
        settype($G2P, 'float');
        $G3V = $array[7]; // GridMs.PhV.phsC
        settype($G3V, 'float');
        $G3A = $array[8]; // GridMs.A.phsC
        settype($G3A, 'float');
        $G3P = $array[9]; // GridMs.W.phsC
        settype($G3P, 'float');
        $FRQ = $array[10]; // GridMs.Hz
        settype($FRQ, 'float');
        $EFF = $array[11]; // Value computed by SBFspot
        settype($EFF, 'float');
        $INVT = $array[12]; // Inverter temperature - n/a for SMA inverters
        settype($INVT, 'float');
        $BOOT = $array[13]; // Booster temperature - n/a for SMA inverters
        settype($BOOT, 'float');
        $KWHT = $array[14]; // Metering.TotWhOut (kWh)
        settype($KWHT, 'float');
        $I1V = $array[15]; // DcMs.Vol[A]
        settype($I1V, 'float');
        $I1A = $array[16]; // DcMs.Amp[A]
        settype($I1A, 'float');
        $I1P = $array[17]; // DcMs.Watt[A]
        settype($I1P, 'float');
        $I2V = $array[18]; // DcMs.Vol[B]
        settype($I2V, 'float');
        $I2A = $array[19]; // DcMs.Amp[B]
        settype($I2A, 'float');
        $I2P = $array[20]; // DcMs.Watt[B]
        settype($I2P, 'float');
        $I3V = null;
        $I3A = null;
        $I3P = null;
        $I4V = null;
        $I4A = null;
        $I4P = null;
        $RET = 'OK';
    } else {
        $RET = 'NOK';
    }
    
} else {
    $RET = 'NOK';
}
?>
